#ifndef GLWIDGET_HPP
#define GLWIDGET_HPP

#include "../libnavigation/navigator_tool.hpp"
#include "scene.hpp"


#include <QtOpenGL/QGLWidget>
#include <QTime>



class glwidget : public QGLWidget
{

    Q_OBJECT

public:

    glwidget(QWidget *parent=0);
    ~glwidget();

    void set_wireframe();
    void set_filled();

    scene current_scene;

    void draw_text(double x,double y,double z,QString text,QFont font);

    void check_opengl_error(const std::string& function_name) const;

protected:
  void initializeGL();
  void paintGL();
  void resizeGL(int width, int height);
  void mousePressEvent(QMouseEvent *event);
  void mouseReleaseEvent(QMouseEvent *event);
  void mouseMoveEvent(QMouseEvent *event);
  void keyPressEvent(QKeyEvent *event);
  void timerEvent(QTimerEvent *event);



private:

  cpe::navigator_tool nav;


  void print_help_start() const;
  void draw_pointer(cpe::navigator_tool& nav) const;
  void draw_orientation(cpe::navigator_tool& nav) const;
  void draw_camera_stat();

  void draw_fps();
  void draw_decorating_info();
  void set_light();


  QTime t_timer;

};


#endif
